import * as Logger from '@nexus/logger';
import * as NexusSchema from '@nexus/schema';
import * as Plugin from '../lib/plugin';
import { RuntimeContributions } from '../lib/plugin';
import { Index } from '../lib/utils';
import * as Schema from './schema';
import * as Server from './server';
import { ContextCreator } from './server/server';
import * as Settings from './settings';
export interface App {
    /**
     * [API Reference](https://www.nexusjs.org/#/api/modules/main/exports/logger)  ⌁  [Guide](todo)
     *
     * ### todo
     */
    log: Logger.Logger;
    /**
     * [API Reference](https://www.nexusjs.org/#/api/modules/main/exports/server)  ⌁  [Guide](todo)
     *
     * ### todo
     *
     */
    server: Server.Server;
    /**
     * todo
     */
    settings: Settings.Settings;
    /**
     * [API Reference](https://www.nexusjs.org/#/api/modules/main/exports/schema) // [Guide](todo)
     *
     * ### todo
     */
    schema: Schema.Schema;
    /**
     * todo
     */
    use(plugin: Plugin.Plugin): void;
    /**
     * todo
     */
    assemble(): any;
    /**
     * This method makes it possible to reset the state of the singleton. This can
     * be useful when working in a development environment where multiple runs of
     * the app (or run-like, e.g. Node module cache being reset) can take place
     * without having state reset. Such an example of that is the Next.js dev
     * mode.
     *
     * @experimental
     */
    reset(): any;
    /**
     * todo
     */
    start(): any;
    /**
     * todo
     */
    stop(): any;
}
export declare type AppState = {
    plugins: Plugin.Plugin[];
    /**
     * Once the app is started incremental component APIs can no longer be used. This
     * flag let's those APIs detect that they are being used after app start. Then
     * they can do something useful like tell the user about their mistake.
     */
    assembled: null | {
        settings: Settings.SettingsData;
        schema: NexusSchema.core.NexusGraphQLSchema;
        missingTypes: Index<NexusSchema.core.MissingType>;
        loadedPlugins: RuntimeContributions<any>[];
        createContext: ContextCreator;
    };
    running: boolean;
    schemaComponent: Schema.LazyState;
};
export declare type PrivateApp = App & {
    private: {
        state: AppState;
    };
};
/**
 * Create new app state. Be careful to pass this state to components to complete its
 * data. The data returned only contains core state, despite what the return
 * type says.
 */
export declare function createAppState(): AppState;
/**
 * Create an app instance
 */
export declare function create(): App;
//# sourceMappingURL=app.d.ts.map